; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - Comments.pb
; Version du fichier : 0.9.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 03-10-2014
; Mise  jour : 24-05-2018
; Code PureBasic : V5.62
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Comments
  
  Declare To_GUI()
  Declare From_GUI()
  Declare GadgetLinking(GadgetID, Flag)
  Declare Initialize(P_ProgramVersion.s)
  Declare Reset()
  Declare RefreshHeader()

  Declare AddDateMask(P_DateMask.s)
  Declare RemoveDateMask(P_DateMaskID.l)
  Declare SelectDateMask(P_DateMaskID.l)
  Declare AskDateMaskEditor()
  Declare DeleteSelectedDateMask()
  Declare DateMaskCount()
  
  Declare WritePrefs(GroupName.s)
  Declare ReadPrefs(GroupName.s)
  
  Declare.s Tabulation(Length.b)
  Declare.s SourceHeader()
  Declare.s Section(Message.s, TabSize.l)
  Declare.s WorkingTime(Buffer.s)
  Declare.s EndOfFile()
  
EndDeclareModule

Module Comments
  
  CompilerSelect #PB_Compiler_OS
      
    CompilerCase #PB_OS_Windows 
      #LineFeed = #CRLF$    
      #TwinLineFeed = #CRLF$ + #CRLF$
      
    CompilerCase #PB_OS_Linux
      #LineFeed = #LF$
      #TwinLineFeed = #LF$ + #LF$
      
    CompilerCase #PB_OS_MacOS
      #LineFeed = #CR$
      #TwinLineFeed = #CR$ + #CR$
      
  CompilerEndSelect
  
  Enumeration
    
    #HEADER_AUTOGENERATED_CODE00
    #HEADER_AUTOGENERATED_CODE01
    #HEADER_GENERATED_BY
    #HEADER_PROJECT_NAME
    #HEADER_FILE_NAME
    #HEADER_FILE_VERSION
    #HEADER_PROGRAMMATION_STATE
    #HEADER_PROGRAMMER_NAME
    #HEADER_PROGRAMMER_NICKNAME
    #HEADER_PROGRAMMER_EMAIL
    #HEADER_CREATION_DATE
    #HEADER_MODIFICATION_DATE
    #HEADER_PUREBASIC_VERSION
    #HEADER_PLATFORM
    
    #HEADER_MAX
    
  EndEnumeration
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dclaration des Structures <<<<<

  Structure Secondary

    UserNameGadget.l
    UserNickNameGadget.l
    UserEmailGadget.l
    TabOptionGadget.l
    TabSizeGadget.l
    DateMaskGadget.l

  EndStructure

  Structure Instance

    UserName.s
    UserNickName.s
    UserEmail.s
    PureBasicVersion.s
    ProgramVersion.s
    TabSizeMin.b
    TabSizeMax.b
    TabSize.b
    TabOption.b
    Header.s[#HEADER_MAX]
    HeaderLenMax.l
    SelectedDateMask.l
    List DateMask.s()

  EndStructure

  Global Secondary.Secondary
  Global Instance.Instance
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'Oprateur GadgetLinking <<<<<

  Procedure GadgetLinking(GadgetID, Flag)
    
    Select Flag
        
      Case 0
        Secondary\UserNameGadget = GadgetID
        
      Case 1
        Secondary\UserNickNameGadget = GadgetID
        
      Case 2 
        Secondary\UserEmailGadget = GadgetID

      Case 3
        Secondary\TabOptionGadget = GadgetID
        
      Case 4
        Secondary\TabSizeGadget = GadgetID
        
      Case 5
        Secondary\DateMaskGadget = GadgetID
        
    EndSelect
    
  EndProcedure
  
  Procedure To_GUI()
    
    SetGadgetText(Secondary\UserNameGadget, Instance\UserName)
    SetGadgetText(Secondary\UserNickNameGadget, Instance\UserNickName)
    SetGadgetText(Secondary\UserEmailGadget, Instance\UserEmail)
    
    SetGadgetAttribute(Secondary\TabSizeGadget, #PB_TrackBar_Minimum, Instance\TabSizeMin)
    SetGadgetAttribute(Secondary\TabSizeGadget, #PB_TrackBar_Maximum, Instance\TabSizeMax)
    
    SetGadgetState(Secondary\TabSizeGadget, Instance\TabSize)
    SetGadgetText(Secondary\TabSizeGadget + 1, Str(Instance\TabSize))
    
    If Instance\TabOption = 0
      SetGadgetState(Secondary\TabOptionGadget, 1)
      DisableGadget(Secondary\TabSizeGadget, 0)
      DisableGadget(Secondary\TabSizeGadget+1, 0)
    Else
      SetGadgetState(Secondary\TabOptionGadget + 1, 1)
      DisableGadget(Secondary\TabSizeGadget, 1)
      DisableGadget(Secondary\TabSizeGadget+1, 1)
    EndIf
    
    ClearGadgetItems(Secondary\DateMaskGadget)
    
    ForEach Instance\DateMask()
      AddGadgetItem(Secondary\DateMaskGadget, ListIndex(Instance\DateMask()), AdvancedDateFormatting::Format(Instance\DateMask(), Date()))  
    Next
    
    SetGadgetState(Secondary\DateMaskGadget, Instance\SelectedDateMask)
    
  EndProcedure
  
  Procedure From_GUI()
    
    Instance\UserName = GetGadgetText(Secondary\UserNameGadget)
    Instance\UserNickName = GetGadgetText(Secondary\UserNickNameGadget)
    Instance\UserEmail = GetGadgetText(Secondary\UserEmailGadget)
    
    If GetGadgetState(Secondary\TabOptionGadget) = 1
      Instance\TabOption = 0
    Else
      Instance\TabOption = 1
    EndIf

    Instance\TabSize = GetGadgetState(Secondary\TabSizeGadget)
    Instance\SelectedDateMask = GetGadgetState(Secondary\DateMaskGadget)
    
  EndProcedure
  
  Procedure RefreshHeader()

    Instance\Header[#HEADER_AUTOGENERATED_CODE00] = Language::Message("AUTOMATICALLY GENERATED CODE, DO NOT MODIFY")
    Instance\Header[#HEADER_AUTOGENERATED_CODE01] = Language::Message("UNLESS YOU REALLY, REALLY, REALLY MEAN IT !!")
    Instance\Header[#HEADER_GENERATED_BY] = Language::Message("Code generated by :") + " " + Language::Message("Dev-Module")
    Instance\Header[#HEADER_PROJECT_NAME] = Language::Message("Project name : the project name here")
    Instance\Header[#HEADER_FILE_NAME] = Language::Message("File name : File name here")
    Instance\Header[#HEADER_FILE_VERSION] = Language::Message("File Version : 0.0.0")
    Instance\Header[#HEADER_PROGRAMMATION_STATE] = Language::Message("Programmation : In progress")
    Instance\Header[#HEADER_PROGRAMMER_NAME] = Language::Message("Programmed by :") + " "
    Instance\Header[#HEADER_PROGRAMMER_NICKNAME] = Language::Message("AKA :") + " "
    Instance\Header[#HEADER_PROGRAMMER_EMAIL] = Language::Message("E-mail :") + " "
    Instance\Header[#HEADER_CREATION_DATE] = Language::Message("Creation Date :") + " "
    Instance\Header[#HEADER_MODIFICATION_DATE] = Language::Message("Last update :") + " "
    Instance\Header[#HEADER_PUREBASIC_VERSION] = Language::Message("Coded for PureBasic :") + " V"
    Instance\Header[#HEADER_PLATFORM] = Language::Message("Platform : Windows, Linux, MacOS X")
    
    For LineID = #HEADER_AUTOGENERATED_CODE00 To #HEADER_MAX - 1
      Instance\HeaderLenMax = Max::Long(Instance\HeaderLenMax, Len(Instance\Header[LineID]))
    Next
    
    ClearGadgetItems(Secondary\DateMaskGadget)
    
    ForEach Instance\DateMask()
      AddGadgetItem(Secondary\DateMaskGadget, ListIndex(Instance\DateMask()), AdvancedDateFormatting::Format(Instance\DateMask(), Date()))  
    Next
    
    SetGadgetState(Secondary\DateMaskGadget, Instance\SelectedDateMask)
    
  EndProcedure
  
  Procedure AddDateMask(P_DateMask.s)
    
    If P_DateMask <> ""
      
      IsFoundAtIndex.l = -1
      
      ForEach Instance\DateMask()
        
        If Instance\DateMask() = P_DateMask
          IsFoundAtIndex = ListIndex(Instance\DateMask())
          Break
        EndIf
        
      Next
      
      If IsFoundAtIndex = -1
        AddElement(Instance\DateMask())
        Instance\DateMask() = P_DateMask
        Instance\SelectedDateMask = ListIndex(Instance\DateMask())
      EndIf
      
    EndIf
    
  EndProcedure
  
  Procedure RemoveDateMask(P_DateMaskID.l)
    
    If SelectElement(Instance\DateMask(), P_DateMaskID)
      DeleteElement(Instance\DateMask(), 1)
      Instance\SelectedDateMask = ListIndex(Instance\DateMask())
    EndIf
    
  EndProcedure
  
  Procedure SelectDateMask(P_DateMaskID.l)
    
    If P_DateMaskID < 0
      P_DateMaskID = 0
    ElseIf P_DateMaskID >= ListSize(Instance\DateMask())
      P_DateMaskID = ListSize(Instance\DateMask()) - 1
    EndIf
    
    Instance\SelectedDateMask = P_DateMaskID
    
    If Instance\SelectedDateMask = -1
      Instance\SelectedDateMask = 0
    EndIf

    SelectElement(Instance\DateMask(), Instance\SelectedDateMask)
        
  EndProcedure
  
  Procedure AskDateMaskEditor()
    
    NewMask.s = AdvancedDateFormatting::DateMaskEditor()

    If NewMask <> ""
      AddDateMask(NewMask)
      To_GUI()
    EndIf
    
  EndProcedure
  
  Procedure DeleteSelectedDateMask()
    
    If MessageRequester(Language::Message("Dev-Module - Warning"), ReplaceString(Language::Message("You are about to delete the date mask : %DATE_MASK%. Would you like to continue ?"), "%DATE_MASK%", Chr(34) + GetGadgetItemText(Secondary\DateMaskGadget, GetGadgetState(Secondary\DateMaskGadget)) + Chr(34)), #PB_MessageRequester_YesNo) = 6
      RemoveDateMask(GetGadgetState(Secondary\DateMaskGadget))
      To_GUI()
    EndIf
    
  EndProcedure
  
  Procedure DateMaskCount()
  
     ProcedureReturn ListSize(Instance\DateMask())
  EndProcedure
  
  
  Procedure Initialize(P_ProgramVersion.s)
    
    Instance\UserName = "Your Name"
    Instance\UserNickName = "Your nickname"
    Instance\UserEmail = "your email"
    Instance\TabSizeMin = 1
    Instance\TabSizeMax = 5
    Instance\TabSize = 2
    Instance\TabOption = 0
    Instance\PureBasicVersion = AskPureBasicCompiler::CurrentVersion()
    Instance\ProgramVersion = P_ProgramVersion
    
  EndProcedure
  
  Procedure Reset()
    
    Secondary\UserNameGadget = 0
    Secondary\UserNickNameGadget = 0
    Secondary\UserEmailGadget = 0
    Secondary\TabOptionGadget = 0
    Secondary\TabSizeGadget = 0
    Secondary\DateMaskGadget = 0
    Instance\UserName = ""
    Instance\UserNickName = ""
    Instance\UserEmail = ""
    Instance\PureBasicVersion = ""
    Instance\ProgramVersion = ""
    Instance\TabSizeMin = 0
    Instance\TabSizeMax = 0
    Instance\TabSize = 0
    Instance\TabOption = 0
    
    For HeaderID = 0 To #HEADER_MAX - 1
      Instance\Header[HeaderID] = ""
    Next
    
    Instance\HeaderLenMax = 0
    Instance\SelectedDateMask = 0
    
    ForEach Instance\DateMask()
      Instance\DateMask() = ""
    Next

    FreeList(Instance\DateMask())
    
  EndProcedure
  
  Procedure WritePrefs(GroupName.s)
    
    PreferenceGroup(GroupName)
    
    WritePreferenceString("UserName", Instance\UserName)
    WritePreferenceString("UserNickName", Instance\UserNickName)
    WritePreferenceString("UserEmail", Instance\UserEmail)
    WritePreferenceLong("TabSize", Instance\TabSize)
    WritePreferenceLong("TabOption", Instance\TabOption)
    
    WritePreferenceLong("DateMask_Max", ListSize(Instance\DateMask()))
    
    ForEach Instance\DateMask()
      WritePreferenceString("DateMask_" + Str(ListIndex(Instance\DateMask())), Instance\DateMask())
    Next
    
    WritePreferenceLong("SelectedDateMask", Instance\SelectedDateMask)
    
  EndProcedure
  
  Procedure ReadPrefs(GroupName.s)

    PreferenceGroup(GroupName)
    
    Instance\UserName = ReadPreferenceString("UserName", Instance\UserName)
    Instance\UserNickName = ReadPreferenceString("UserNickName", Instance\UserNickName)
    Instance\UserEmail = ReadPreferenceString("UserEmail", Instance\UserEmail)
    Instance\TabSize = ReadPreferenceLong("TabSize", Instance\TabSize)
    Instance\TabOption = ReadPreferenceLong("TabOption", Instance\TabOption)
   
    DateMask_Max = ReadPreferenceLong("DateMask_Max", 0)
    
    If DateMask_Max = 0 
      AddDateMask("%dd-%mm-%yyyy")
      Instance\SelectedDateMask = 0
    Else
      
      For DateMaskID = 0 To DateMask_Max - 1
        AddDateMask(ReadPreferenceString("DateMask_" + Str(DateMaskID), "%dd-%mm-%yyyy"))
      Next
      
    EndIf 
    
    SelectDateMask(ReadPreferenceLong("SelectedDateMask", Instance\SelectedDateMask))
    
  EndProcedure
  
  Procedure.s SourceHeader()
    
    SelectElement(Instance\DateMask(), Instance\SelectedDateMask)
    
    Separation.s = LSet("; ", Instance\HeaderLenMax + 7, "<")
    
    Buffer.s + Separation + #LineFeed
    
    For LineID = #HEADER_AUTOGENERATED_CODE00 To #HEADER_AUTOGENERATED_CODE01
      Buffer + "; " + UCase(Instance\Header[LineID]) + #LineFeed
    Next
    
    Buffer + Separation + #LineFeed
    
    For LineID = #HEADER_GENERATED_BY To #HEADER_PLATFORM
      
      Select LineID
          
        Case #HEADER_GENERATED_BY
          Buffer + "; " + Instance\Header[LineID] + Instance\ProgramVersion + #LineFeed
          
        Case #HEADER_PROGRAMMER_NAME
          Buffer + "; " + Instance\Header[LineID] + Instance\UserName + #LineFeed
          
        Case #HEADER_PROGRAMMER_NICKNAME
          Buffer + "; " + Instance\Header[LineID] + Instance\UserNickName + #LineFeed
          
        Case #HEADER_PROGRAMMER_EMAIL
          Buffer + "; " + Instance\Header[LineID] + Instance\UserEmail + #LineFeed
          
        Case #HEADER_CREATION_DATE, #HEADER_MODIFICATION_DATE
          Buffer + "; " + Instance\Header[LineID] + AdvancedDateFormatting::Format(Instance\DateMask(), Date()) + #LineFeed
          
        Case #HEADER_PUREBASIC_VERSION
          Buffer + "; " + Instance\Header[LineID] + Instance\PureBasicVersion + #LineFeed
          
        Default
          Buffer + "; " + Instance\Header[LineID] + #LineFeed
          
      EndSelect
      
    Next
    
    ProcedureReturn Buffer + Separation + #TwinLineFeed
  EndProcedure
  
  Procedure.s Tabulation(Length.b)
    
    If Instance\TabOption = 0
      Length = Length * Instance\TabSize
      Character.s = Chr(32)
    Else
      Character = Chr(9)
    EndIf
    
    ProcedureReturn LSet("", Length, Character)
  EndProcedure
  
  Procedure.s Section(Message.s, TabSize.l)
    
    Commentaire.s = "; <<<<< " + Message + " <<<<<"
    
    ProcedureReturn Tabulation(TabSize) + LSet("; ", Len(Commentaire), "<") + #LineFeed + Tabulation(TabSize) + Commentaire + #TwinLineFeed
  EndProcedure

  Procedure.s WorkingTime(Buffer.s)
    
    LineCount = CountString(Buffer, #LineFeed)
    Taux.d = LineCount / (Chrono::Consult(0) / 1000.0)
    
    Stats::InsertTopBottomOutRatesTimes(Taux, Chrono::Consult(0))
    Commentaire.s = "; <<<<< " + ReplaceString(ReplaceString(Language::Message("Code generated in : %TIME% seconds (%RATE% lines/second)"), "%TIME%", Chrono::Format(0, "%ss.%mss")), "%RATE%", StrD(Taux,2)) + " <<<<<"
    Seperator.s = LSet("; ", Len(Commentaire), "<")

    ProcedureReturn Seperator + #LineFeed + Commentaire + #LineFeed + Seperator + #TwinLineFeed
  EndProcedure
  
  Procedure.s EndOfFile()
    
    Comment.s = "; <<<<< " + Language::Message("END OF FILE") + " <<<<<"
    Separator.s = LSet("; ", Len(Comment), "<") 
    
    ProcedureReturn Separator + #LineFeed + UCase(Comment) + #LineFeed + Separator
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = -----
; EnableXP
; CompileSourceDirectory