; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Module - V0.0.1
; Nom du projet : AskPureBasicCompiler - Module
; Nom du fichier : AskPureBasicCompiler - Module.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 20-02-2015
; Mise  jour : 20-02-2015
; Cod pour : PureBasic 5.31
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule AskPureBasicCompiler
  
  Declare Initialize()
  Declare.s CurrentVersion()
  Declare.s CurrentOS()
  Declare.s CurrentVersionOS()
  Declare.s Help()
  Declare Reset()
  
EndDeclareModule

Module AskPureBasicCompiler
  
  CompilerSelect #PB_Compiler_OS
      
    CompilerCase #PB_OS_Windows 
      #LineFeed = #CRLF$

    CompilerCase #PB_OS_Linux
      #LineFeed = #LF$

    CompilerCase #PB_OS_MacOS
      #LineFeed = #CR$
      
  CompilerEndSelect
  
  Structure Instance
    
    CompilerProgramFile.s
    CompilerFile.s
    CompilerHome.s
    RunParamVersion.s
    RunParamHelp.s
    CurrentVersion.s
    CurrentOS.s
    CurrentVersionOS.s
    Help.s
    IsInit.b
    
  EndStructure
  
  Global Instance.Instance
  
  Procedure.s FindPureBasicCompiler(Directory.s, FileName.s)
    
    Protected DirectoryHandle.i, EntryName.s, Output.s
    
    CompilerIf #PB_Compiler_OS = #PB_OS_Windows 
      
      If Right(Directory, 1) <> "\"
        Directory + "\"
      EndIf
      
    CompilerElse
      
      If Right(Directory, 1) <> "/"
        Directory + "/"
      EndIf
      
    CompilerEndIf
    
    DirectoryHandle = ExamineDirectory(#PB_Any, Directory, "*.*") 
    
    If DirectoryHandle <> 0
      
      While NextDirectoryEntry(DirectoryHandle) 
        
        EntryName = DirectoryEntryName(DirectoryHandle)
        
        If EntryName <> "." And EntryName <> ".." 
          
          Select DirectoryEntryType(DirectoryHandle)
              
            Case #PB_DirectoryEntry_File
              
              If EntryName = FileName
                Output = Directory
                Break
              Else
                Output = ""
              EndIf
              
            Case #PB_DirectoryEntry_Directory 
              
              Output = FindPureBasicCompiler(Directory + EntryName, FileName)
              
              If Output <> ""
                Break
              EndIf
              
          EndSelect
          
        EndIf
        
      Wend
      
      FinishDirectory(DirectoryHandle)
      
    EndIf
    
    ProcedureReturn Output
  EndProcedure 
  
  Procedure Initialize()
    
    CompilerSelect #PB_Compiler_OS
        
      CompilerCase #PB_OS_Windows 
        Instance\CompilerFile = "pbcompiler.exe"
        Instance\CompilerHome = FindPureBasicCompiler("C:\", Instance\CompilerFile)
        Instance\RunParamVersion = "/VERSION"
        Instance\RunParamHelp = "/HELP"

      CompilerCase #PB_OS_Linux
        Instance\CompilerFile = "pbcompiler"
        
        If GetEnvironmentVariable("PUREBASIC_HOME") <> ""
          Instance\CompilerHome = FindPureBasicCompiler(GetEnvironmentVariable("PUREBASIC_HOME") + "compilers/", Instance\CompilerFile)
        EndIf
        
        Instance\RunParamVersion = "-v"
        Instance\RunParamHelp = "-h"

        If Instance\CompilerHome = ""
          Instance\CompilerHome = FindPureBasicCompiler("/usr/share/purebasic/compilers/", Instance\CompilerFile)
        EndIf
        
        If Instance\CompilerHome = ""
          Instance\CompilerHome = FindPureBasicCompiler("/bin/", Instance\CompilerFile)
        EndIf
        
        If Instance\CompilerHome = ""
          Instance\CompilerHome = FindPureBasicCompiler(GetHomeDirectory(), Instance\CompilerFile)
        EndIf
        
      CompilerCase #PB_OS_MacOS
        Instance\CompilerFile = "pbcompiler"
        Instance\CompilerHome = FindPureBasicCompiler("/??????/", Instance\CompilerFile)
        Instance\RunParamVersion = "-v"
        Instance\RunParamHelp = "-h"
   
    CompilerEndSelect
    
    Instance\CompilerProgramFile = Instance\CompilerHome + Instance\CompilerFile
    Instance\IsInit = #True  
    
  EndProcedure

  Procedure.s CurrentVersion()
    
    Protected LIndex.l, RIndex.l, PB_Compiler_Handle.i
    
    If Instance\CurrentVersion = ""
      
      If Instance\IsInit = #False
        Initialize()
      EndIf
      
      PB_Compiler_Handle = RunProgram(Instance\CompilerProgramFile, Instance\RunParamVersion, "", #PB_Program_Open|#PB_Program_Read|#PB_Program_Hide)
      
      If PB_Compiler_Handle 
        
        While ProgramRunning(PB_Compiler_Handle)
          If AvailableProgramOutput(PB_Compiler_Handle)
            Instance\CurrentVersion = ReadProgramString(PB_Compiler_Handle)
          EndIf
        Wend
        
        CloseProgram(PB_Compiler_Handle)
        
        LIndex = FindString(Instance\CurrentVersion, "PureBasic", 0) 
        RIndex = FindString(Instance\CurrentVersion, "(", 0) 
        
        If LIndex And RIndex 
          LIndex + Len("PureBasic") 
          Instance\CurrentVersion = Trim(Mid(Instance\CurrentVersion, LIndex, RIndex - LIndex))
        EndIf 
        
      EndIf
      
    EndIf
    
    ProcedureReturn Instance\CurrentVersion
  EndProcedure
  
  Procedure.s CurrentOS()
    
    Protected LIndex.l, RIndex.l, PB_Compiler_Handle.i
    
    If Instance\CurrentOS = ""
      
      If Instance\IsInit = #False
        Initialize()
      EndIf
      
      PB_Compiler_Handle = RunProgram(Instance\CompilerProgramFile, Instance\RunParamVersion, Instance\CompilerHome, #PB_Program_Open|#PB_Program_Read|#PB_Program_Hide)
      
      If PB_Compiler_Handle 
        
        While ProgramRunning(PB_Compiler_Handle)
          If AvailableProgramOutput(PB_Compiler_Handle)
            Instance\CurrentOS = ReadProgramString(PB_Compiler_Handle)
          EndIf
        Wend
        
        CloseProgram(PB_Compiler_Handle)
        
        LIndex = FindString(Instance\CurrentOS, "(", 0) + 1 
        RIndex = FindString(Instance\CurrentOS, ")", 0)
        
        If LIndex And RIndex
          Instance\CurrentOS = Trim(Mid(Instance\CurrentOS, LIndex, RIndex - LIndex))
        EndIf 
        
      EndIf
      
    EndIf
    
    ProcedureReturn "(" + Instance\CurrentOS + ")"
  EndProcedure
  
  Procedure.s CurrentVersionOS()
    
    Protected LIndex.l, RIndex.l, PB_Compiler_Handle.i
    
    If Instance\CurrentVersionOS = ""
      
      If Instance\IsInit = #False
        Initialize()
      EndIf

      PB_Compiler_Handle = RunProgram(Instance\CompilerProgramFile, Instance\RunParamVersion, Instance\CompilerHome, #PB_Program_Open|#PB_Program_Read|#PB_Program_Hide)
      
      If PB_Compiler_Handle 
        
        While ProgramRunning(PB_Compiler_Handle)
          If AvailableProgramOutput(PB_Compiler_Handle)
            Instance\CurrentVersionOS = ReadProgramString(PB_Compiler_Handle)
          EndIf
        Wend
        
        CloseProgram(PB_Compiler_Handle)
        
        LIndex = FindString(Instance\CurrentVersionOS, "PureBasic", 0)
        RIndex = FindString(Instance\CurrentVersionOS, "- (c)", 0)
        
        If LIndex And RIndex
          Instance\CurrentVersionOS = Trim(Mid(Instance\CurrentVersionOS, LIndex, RIndex - LIndex))
        EndIf 
        
      EndIf
      
    EndIf
    
    ProcedureReturn Instance\CurrentVersionOS
  EndProcedure
  
  Procedure.s Help()

    If Instance\Help = ""
      
      If Instance\IsInit = #False
        Initialize()
      EndIf
      
      PB_Compiler_Handle = RunProgram(Instance\CompilerProgramFile, Instance\RunParamHelp, Instance\CompilerHome, #PB_Program_Open|#PB_Program_Read|#PB_Program_Hide)
      
      If PB_Compiler_Handle 
        
        While ProgramRunning(PB_Compiler_Handle)
          If AvailableProgramOutput(PB_Compiler_Handle)
            Instance\Help + ReadProgramString(PB_Compiler_Handle) + #LineFeed
          EndIf
        Wend
        
        CloseProgram(PB_Compiler_Handle)
        
      EndIf
      
    EndIf
    
    ProcedureReturn Instance\Help
  EndProcedure
  
  Procedure Reset()

    Instance\CompilerProgramFile = ""
    Instance\CompilerFile = ""
    Instance\CompilerHome = ""
    Instance\RunParamVersion = ""
    Instance\RunParamHelp = ""
    Instance\CurrentVersion = ""
    Instance\CurrentOS = ""
    Instance\CurrentVersionOS = ""
    Instance\Help = ""
    Instance\IsInit = #False
    
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (51000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

CompilerIf #PB_Compiler_IsMainFile
  
  AskPureBasicCompiler::Initialize()
  
  Debug AskPureBasicCompiler::CurrentVersion()
  Debug AskPureBasicCompiler::CurrentOS()
  Debug AskPureBasicCompiler::CurrentVersionOS()
  ;Debug AskPureBasicCompiler::Help()
  
  AskPureBasicCompiler::Reset()
  
CompilerEndIf

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = ---
; EnableXP
; CompileSourceDirectory
; EnableUnicode